﻿using UnityEngine;
using System.Collections;

public class CustomerAI : MonoBehaviour {

	GameObject exitPoint;

	public GameObject[] shelves;
	public Transform selectedShelf;
	Transform playerTransform;
	NavMeshAgent agentti;

	public bool gettingFromShelf = false;
	public bool hasBoard = false;
	public bool chasingPlayer = false;

	bool updateAgent = true;

	public GameObject money;

	public GameObject[] boards;

	public GameObject sprite;

	GameObject waveManager;

	AudioSource sorsa;

	public AudioClip dropMoney;

	public AudioClip[] speak;

	public float voiceRangeMin = 0.75f;
	public float voiceRangeMax = 1.25f;

	public bool female = false;

	// Use this for initialization
	void Awake () {
		sorsa = GetComponent<AudioSource> ();
		sorsa.pitch = Random.Range (0.75f, 1.25f);
		waveManager = GameObject.Find("GameManager");
		exitPoint = GameObject.Find ("ExitPoint");
		agentti = GetComponent<NavMeshAgent> ();
		shelves = GameObject.FindGameObjectsWithTag ("Shelf");
		playerTransform = GameObject.Find ("Player").transform;
		ChooseBoardSource ();
		StartCoroutine (RandomBanter ());
	}
	
	// Update is called once per frame
	void Update () {
		if (agentti.velocity.magnitude < 0.1f && !hasBoard && gettingFromShelf) {
			ChooseBoardSource ();
		}
		if (chasingPlayer && !hasBoard && updateAgent) {
			agentti.SetDestination (playerTransform.position);
			updateAgent = false;
			StartCoroutine (RefreshAgentUpdate ());
		}
	}

	IEnumerator RefreshAgentUpdate (){
		yield return new WaitForSeconds (0.2f);
		updateAgent = true;
	}

	void ChooseBoardSource(){
		gettingFromShelf = false;
		for (int i = 0; i < shelves.Length; i++) {
			if (shelves [i].GetComponent<ShelfContainedSurfBoards> ().surfBoards > 0) {
				selectedShelf = shelves [i].transform;
				agentti.SetDestination (selectedShelf.transform.position);
				gettingFromShelf = true;
				break;
			}
		}
		if (!gettingFromShelf) {
			//Start chasing player
			Debug.Log("StartChasingPlayer");
			chasingPlayer = true;
		}
	}

	void OnTriggerEnter(Collider other){
		if (other.tag == "ShelfServiceTrigger" && !hasBoard) {
			if (other.GetComponentInParent<ShelfContainedSurfBoards> ().surfBoards > 0) {
				other.transform.parent.SendMessage ("RemoveBoard");
				ExitStore ();
			}
		}
	}

	void OnCollisionEnter(Collision col){
		if (col.collider.tag == "SurfBoard" && !hasBoard) {
			Destroy (col.gameObject);
			ExitStore ();
		} 
		else if (col.collider.tag == "Player" && !hasBoard && chasingPlayer) {
			col.gameObject.SetActive (false);
			waveManager.SendMessage ("GameOver");
		}
	}

	void ExitStore (){
		hasBoard = true;
		boards [Random.Range (0, boards.Length)].SetActive (true);
		sorsa.PlayOneShot (dropMoney);
		Instantiate (money, transform.position, transform.rotation);
		agentti.SetDestination (exitPoint.transform.position);
		chasingPlayer = false;
		Destroy (sprite, 9f);
		Destroy (gameObject, 10f);
	}

	IEnumerator RandomBanter(){
		if (!female) {
			yield return new WaitForSeconds (Random.Range (0f, 30f));
			sorsa.PlayOneShot (speak [Random.Range (0, speak.Length)]);
		}
	}
}
