﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class ThrowSurfBoards : MonoBehaviour {

	public Slider powerSlider;

	public GameObject surfBoard;
	public float throwSpeed = 5f;
	public float throwRotationSpeed = 5f;
	public Transform throwHere;

	float cooldown = 0f;
	public float currentCooldown = 0.1f;
	public float maxCooldown = 1f;

	AudioSource sorsa;

	public AudioClip[] throwSound;

	void Start (){
		sorsa = GetComponent<AudioSource> ();
	}

	// Update is called once per frame
	void Update () {
	
		if(Input.GetButton("Fire1") && cooldown <= 0f){
			sorsa.pitch = Random.Range (0.75f, 1.25f);
			sorsa.PlayOneShot (throwSound [Random.Range (0, throwSound.Length)]);
			GameObject boardInstance = Instantiate (surfBoard, throwHere.position, throwHere.rotation) as GameObject;
			Rigidbody rb = boardInstance.GetComponent<Rigidbody> ();
			rb.AddForce (throwHere.forward * throwSpeed, ForceMode.Impulse);
			rb.AddTorque (0f, Random.Range(-throwRotationSpeed, throwRotationSpeed), 0);
			cooldown = currentCooldown;
			currentCooldown *= 1.75f;
			if (currentCooldown > maxCooldown) {
				currentCooldown = maxCooldown;
			}
		}

		if (cooldown > 0f) {
			cooldown -= 1f * Time.deltaTime;
		}
		else if (cooldown < 0f) {
			cooldown = 0f;
		}


		if (currentCooldown < 0.1f) {
			currentCooldown = 0.1f;
		}
		else if (currentCooldown > 0f) {
			currentCooldown -= 0.5f * Time.deltaTime;
		}

		powerSlider.value = currentCooldown;

	}
}
