﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class WaveManager : MonoBehaviour {

	public int wave = 1;

	public int timeBetweenWaves = 30;

	public GameObject[] spawner;

	public GameObject[] customer;

	public Animator indicatorAnimator;

	public bool playerAlive = true;

	public GameObject gameOverScreen;

	GameObject playerObject;
	GameObject arm;

	public Text yourScore;
	public Text first;

	bool introDone;

	AudioSource sorsa;

	public AudioClip[] gameOver;

	public WindVolume windSoundObject;

	public MusicControl musicObject;

	// Use this for initialization
	void Start () {
		musicObject = Camera.main.GetComponent<MusicControl> ();
		spawner = GameObject.FindGameObjectsWithTag ("Spawner");
		playerObject = GameObject.Find ("Player");
		arm = GameObject.Find ("ArmParent");
		StartCoroutine (SpawnWaves ());
		StartCoroutine (SpawnRandomCustomers ());
		sorsa = GetComponent<AudioSource> ();
	}
	
	// Update is called once per frame
	IEnumerator SpawnWaves () {
		if (playerAlive) {
			yield return new WaitForSeconds (timeBetweenWaves - 25);
			indicatorAnimator.SetBool ("Storm", false);
			musicObject.storm = false;
			windSoundObject.storm = false;
			yield return new WaitForSeconds (timeBetweenWaves - 5);
			indicatorAnimator.SetBool ("Storm", true);
			musicObject.storm = true;
			windSoundObject.storm = true;
			for (int i = 0; i < wave * 15; i++) {
				Instantiate (customer[Random.Range(0, customer.Length)], spawner [Random.Range (0, spawner.Length - 1)].transform.position, Quaternion.identity);
			}
			wave += 1;
			StartCoroutine (SpawnWaves ());
		}
	}

	IEnumerator SpawnRandomCustomers () {
		if (playerAlive) {
			if (!introDone) {
				yield return new WaitForSeconds (15);
				introDone = true;
			}
			yield return new WaitForSeconds (Random.Range(3f, 5f));
			Instantiate (customer[Random.Range(0, customer.Length)], spawner [Random.Range (0, spawner.Length - 1)].transform.position, Quaternion.identity);
			StartCoroutine (SpawnRandomCustomers ());
		}
	}

	void GameOver () {
		sorsa.PlayOneShot (gameOver [Random.Range (0, gameOver.Length)]);
		arm.SetActive (false);
		playerAlive = false;
		gameOverScreen.SetActive (true);
		int score = playerObject.GetComponent<PickUpMoney> ().money;
		int bestScore = PlayerPrefs.GetInt ("HighScore");
		first.text = "High Score: $" + bestScore;
		yourScore.text = "You earned $" + score;
		if (score > bestScore) {
			PlayerPrefs.SetInt ("HighScore", score);
		}
	}
}
